#include <stdio.h>
#include <signal.h>
#include <sys/console.h>
#include <sys/types.h>
#include <sys/vtkd.h>
#include <sys/termio.h>

struct termio otermio;
struct termio ntermio;

extern int errno;
unsigned char *screen,*malloc();
int delete();
int r,g,b,j;
char *ylines[2048];

main(argc,argv)
int argc; char *argv[];
{
	char fname[80];
	char s[80];
	char palette[768];
	FILE *fp;
	char *sp;
	int argcnt = 1;
	int magic;
	int twidth;
	int theight;
	int result;
	int i,ch;
	int x,y;
	int xaspect,yaspect;

	if (argc < 2) {
		fprintf (stderr,"Aufruf: %s BILD[.TGA] ...\n",
			argv[0]);
	}
	while (--argc) {
		strcpy (fname,argv[argcnt++]);
		if ((fp=fopen(fname,"r"))==NULL) {
			strcat (fname,".tga");
			if ((fp=fopen(fname,"r"))==NULL) {
				fprintf (stderr,"%s: %s nicht gefunden.\n",
					argv[0],fname);
				exit (errno);
			}
		}
		fread (&i,4,1,fp);
		if ( i != 0x00010100 ) no_targa("Magic header error");
		fseek (fp,0x0c,0L);
		twidth = 0;
		fread (&twidth,2,1,fp);
		theight = 0;
		fread (&theight,2,1,fp);
		fread (&i,2,1,fp);
		if ((i & 255) != 8) no_targa ("Keine 8-Bit Farbtiefe");

		printf ("Aktuelles Bild = %s\n",fname);
		printf ("X-Aufloesung = %4d Y-Aufloesung = %4d\n",
			twidth,theight);

		fread (&palette[0],1,768,fp);	
		for (i=theight-1;i >= 0;i--) {
			if ((ylines[i]=malloc((twidth+16) & 0xfff0))==NULL) {
				fprintf (stderr,"%s: malloc() failed\n",
					argv[0]);
				exit (errno);
			}
			fread (ylines[i],1,twidth,fp);
		}
		fclose (fp);

		printf ("Mit [CR] Bild anschauen:\n");
		gets (s);

		for (i=1;i!=14;i++) {
			signal (i,SIG_IGN);
			signal (i,delete);
		}
		if ((result=ioctl(0,SW_VGA13,0))==-1) ioctl_err ("SW_VGA13");
		if ((result=ioctl(0,MAPVGA,0))==-1) ioctl_err ("MAPVGA");
		screen = (unsigned char *) result;
		if ((result=ioctl(0,KDENABIO,0))==-1) ioctl_err ("KDENABIO");
		for (i=0;i!=256;i++) {
			out (0x03c8,i);
			out (0x03c9,(palette[i*3+2]) >> 2);
			out (0x03c9,(palette[i*3+1]) >> 2);
			out (0x03c9,(palette[i*3]) >> 2);
		}
		xaspect = yaspect = 0;
		for (y=0;y!=200;y++) {
			i = ((twidth-xaspect) > 320) ? 320 : (twidth-xaspect);
			sp = ylines[y+yaspect];
			memcpy (screen+y*320,sp+xaspect,i);
			if (y+yaspect >= theight) break;
		}
		raw();
		ch = 0;
		do {
			read (0,&ch,1);
			switch (ch) {
				case 'j' :
					if (yaspect < theight) yaspect++;
					break;

				case 'k' :
					if (yaspect > 0) yaspect--;
					break;

				case 'l' :
					if (xaspect < twidth) xaspect++;
					break;

				case 'h' :
					if (xaspect > 0) xaspect--;
					break;
				default :
					break;
			}
			for (y=0;y!=200;y++) {
				i=((twidth-xaspect)>320)?320:(twidth-xaspect);
				sp = ylines[y+yaspect];
				memcpy (screen+y*320,sp+xaspect,i);
				if (y+yaspect >= theight) break;
			}
		} while (ch != 'q');
		for (i=0;i!=theight;i++) free (ylines[i]);
		if ((ioctl(0,SW_VGA80x25,0))==-1) ioctl_err ("SW_VGA80x25");
		ioctl(0, TCSETA, &otermio);
	}
}

raw() {
	ioctl(0,TCGETA,&otermio);	/* Die alten Werte sichern */
	ntermio.c_iflag = 0;		/* Die neuen Werte setzen */
	ntermio.c_oflag = 0;
	ntermio.c_cflag = otermio.c_cflag;
	ntermio.c_lflag = 0;
	ntermio.c_line = otermio.c_line;
	ntermio.c_cc[VMIN] = 1;
	ntermio.c_cc[VTIME] = 0;
	ioctl(0, TCSETA, &ntermio);	/* und aktivieren */
	/* Damit haben wir die Tastatur in den RAW Modus geschaltet */
}

no_targa(char *s) {
	fprintf (stderr,"Kein TARGA Bildformat: %s\n",s);
	exit (1);
}

ioctl_err(s)
char *s;
{
	fprintf (stderr,"ioctl error %s errno =%d\n",
		s,errno);
	exit (errno);
}

int delete(sig)
int sig;
{
	if ((ioctl(0,SW_VGA80x25,0))==-1) ioctl_err ("SW_VGA80x25");
	if (sig) fprintf (stderr,"SIGNAL %2d received.\n",sig);
	fprintf (stderr,"Program terminated.\n");
	exit (sig);
}

in (reg)
int reg;
{
	_asm {
		mov	dx,word ptr reg
		in	al,dx
		movzx	eax,al
	}
}

out (reg,val)
int reg,val;
{
	_asm {
		mov	dx,word ptr reg
		mov	al,byte ptr val
		out	dx,al
	}
}
